/*  lcd.cpp
    Low level LCD driver for SED1520 122x32 graphic LCDs

    09.06.2001: tk, initial implementation.

    Copyright (c)2001 by Thomas Kindler, thomas.kindler@gmx.de

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version. Read the
    full License at http://www.gnu.org/copyleft for more details.
*/

#include <stdio.h>
#include <conio.h>
#include <string.h>
#include "sc12/hwapi.h"
#include "sc12/rtos.h"
#include "misc.h"
#include "ks0108.h"

/****************************
 *** TEXT DISPLAY         ***/

void TLCD_init() {

  pfe_enable_bus(0xff, true);
  pfe_enable_pcs(5);          //CS 1
  pfe_enable_pcs(6);          //CS 2
  //pfe_enable_timer(TIMER_OUT0);


  printf("Init LCD...\n");
  RTX_Sleep_Time(150);
  TLCD_send(48,false);
  RTX_Sleep_Time(420);
  TLCD_send(48,false);
  RTX_Sleep_Time(20);
  TLCD_send(48,false);
  RTX_Sleep_Time(420);
  TLCD_send(56,false);
  RTX_Sleep_Time(240);
  TLCD_send(8,false);
  RTX_Sleep_Time(240);
  TLCD_send(1,false);  //Ich bin aber fr das Lschen...!!!
  RTX_Sleep_Time(20);
  TLCD_send(12,false); //Display An ohne Cursor!
  RTX_Sleep_Time(170);
  TLCD_send(6,false);
  RTX_Sleep_Time(20);
  TLCD_send(1,false);
  RTX_Sleep_Time(20);
}

/*
 * Sets cursor to certain position
 * col  = column [0-19]
 * line = line [0-3]
 */
void pos_cursor(unsigned char col, unsigned char line)
{
unsigned char offset=0;
unsigned char pos=0;

  /* some sanity checking */
  if (col>(16)) {
    col=0;
    line++;
  }
  if (line>(2-1)) line=0;

  /* line address offsets (weird, aren't they?) */
  switch (line) {
    case 0: offset=0;
            break;
    case 1: offset=64;
            break;
    case 2: offset=20;
            break;
    case 3: offset=84;
            break;
  }

  /* Command for addressing is 128 so we add all this here */
  pos=offset+col+128;
  /* Update our private position counter */
//  dline=line;
//  dcol=col;
  /* now write it out */
  TLCD_send(pos,false);
  RTX_Sleep_Time(20);
}

void TLCD_Kette(char *kette)
{

  for (int i=0;i<strlen(kette);i++)
    {
     TLCD_send(kette[i],true);
    }
}

void TLCD_clear() {
  TLCD_send(0x01, false);  //-> 0000 0001b //Lscht das Display, und setzt den Cursor wieder auf ADR 0
}


void TLCD_send(unsigned char Daten, bool Data) {
  RTX_Sleep_Time(2);
  if (Data) {
    outp(0x502, Daten);           //Datenbyte Ausgeben.
  } else {
    outp(0x500, Daten);           //Befehlsbyte Ausgeben.
  }
}
