#ifndef ISO9660_HPP
#define ISO9660_HPP

#define ISO_DIR_NODE            1        // identifies a directory node
#define ISO_CURRENT_DIR_NODE    2        // link back to current dir
#define ISO_PARENT_DIR_NODE     4        // link to parent dir
#define ISO_FILE_LIST_SIZE      65535u   // size of filelist

// directory list node
//
typedef struct ISO_FILE_NODE {
    ISO_FILE_NODE  *next;          // pointer to next node
    ISO_FILE_NODE  *dir;           // directory pointer
    ulong           lba;           // block address
    ulong           len;           // file length
    char            flags;         // flags
    char            filename[1];   // zero terminated filename, stored
                                   // directly after this structure.
} ISO_FILE_NODE;


// cd filesystem volume
//
typedef  struct  {
    bool   isInitialized;
    bool   isJoliet;

    char   volumeID[32];
    ulong  volumeSize;

    ulong  fileNum, dirNum;
    ulong  fileBytes;

    ISO_FILE_NODE   root;            // root node
    ISO_FILE_NODE  *fileList;        // memory block for filenames
    ISO_FILE_NODE  *lastFile;        // pointer to last file

    ulong           fileListLength;  // current size of filelist
                                     // in bytes (used by AddNode())
} ISO_VOLUME;


extern  ERROR  ISO_InitVolume( ISO_VOLUME *vol );


#endif
