#ifndef MISC_HPP
#define MISC_HPP

// endianess conversion -----
//
inline short SwapShort( const short &i )  {
  return ((i << 8) & 0xff00) |
         ((i >> 8) & 0x00ff);
}

inline long  SwapLong( const long &i )  {
  return ((i << 24) & 0xff000000L) |
         ((i <<  8) & 0x00ff0000L) |
         ((i >>  8) & 0x0000ff00L) |
         ((i >> 24) & 0x000000ffL);
}

extern void REP_INSW( void *dest, int port, int numWords );
extern void REP_INSB( void *dest, int port, int numBytes );

// convert space-padded iso string to '\0'-terminated string
//   always remember that c-strings need one more byte to store
//   the '\0' terminator. so we need to alloc length+1 bytes to
//   store the conversion result. This is important, because
//   it deviates from the standard strncpy() rule.
//
extern  void  IsoToCString( char *cstring, const char *isostring,
                            int    length, bool  isUnicode );

#endif
