/*  mp3player hardware test

	 28.12.2002: sf, Source Opening without MAS Support
    xx.12.2002: sf, Replace VS1001 druch MAS 3587 (Project removed)
    24.12.2001: sf, Play MP3 CD Feauture
    24.12.2001: sf, Play Audio CD Feature
    15.05.2001: tk, initial implementation.

    Copyright (c)2000 by Thomas Kindler, thomas.kindler@gmx.de

    This program is free software; you can redistribute it and/or
    modify it under the terms of the GNU General Public License as
    published by the Free Software Foundation; either version 2 of
    the License, or (at your option) any later version. Read the
    full License at http://www.gnu.org/copyleft for more details.
*/

// include files -----
//
#pragma option -1              // create 80186 code

#include <alloc.h>
#include <stdio.h>
#include <dos.h>
#include <dir.h>
#include <io.h>
#include <time.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>
#include <assert.h>
#include <string.h>
#include "sc12/amd186.h"
#include "sc12/rtos.h"
#include "sc12/hwapi.h"
#include "chkbios.h"
#include "ztimer.h"
#include "ks0108.h"
#include "remote.h"
//#include "gfxlcd.h"
#include "id3v1.h"
#include "vs1001.h"
#include "misc.h"
#include "inet/httpget.h"
#include "inet/url.h"
#include "mpbuf.h"
#include "mpeg.h"
#include "readline.h"
#include "player/cdplayer.hpp"

/**************************
 ** NEU SF
 **************************/

#define  VERSION "V. 27/12/02"

#include "ide/mpplayer.hpp"
#include "ide/ata.hpp"
#include "ide/cdrom.hpp"
#include "ide/iso9660.hpp"
#include "i2c_api.h"
#include "mas/masi2c.hpp"
#include "volctrl.h"


void api_sleep(int ms)
{
   union REGS inregs;
   union REGS outregs;
   struct SREGS segregs;

   inregs.x.ax = 0x0900;
   inregs.x.bx = ms;
   int86x(0xAC,&inregs,&outregs,&segregs);
}


int IsAudioCD(void) {
  CD_TOC  toc;
  CD_ReadTOC( &toc );
  if (toc.num_tracks <= 1) return false;
  return true;
}


ulong getNextMP3(ISO_VOLUME  *vol , ulong lba33) {
  ISO_FILE_NODE    *node = vol->fileList;
  ulong            lba = lba33;

   for (; node; node = node->next)
   if  ((node->lba <= lba) && (node->lba + (node->len/2048)>=lba))
   {
      return node->next->lba;
   }
   return 0; // Falls nichts gefunden wird, dann fangen wir wieder am ersten Lied an.
}

ulong getPrevMP3(ISO_VOLUME  *vol , ulong lba33) {
   ISO_FILE_NODE    *node = vol->fileList;
   ulong            lba = lba33;
   ulong            OldLba=0;


   for (; node; node = node->next) {
   if  ((node->lba <= lba) && (node->lba + (node->len/2048)>=lba))
       return OldLba;
   OldLba = node->lba;
   } //for
}


void UpdateLCDInfo(ISO_VOLUME  *vol , ulong lba33) {
    ISO_FILE_NODE    *node = vol->fileList;
    ulong            lba = lba33;

    char infotext[16];
    //TLCD_clear();
    pos_cursor(0, 0);
    sprintf(infotext,"Spiele: X / %d", vol->fileNum);
    TLCD_Kette(infotext);

   for (; node; node = node->next)
   if  ((node->lba <= lba) && (node->lba + (node->len/2048)>=lba))
   {
     char filename[12];
        sscanf(node->filename,"%s;%s",filename);
        pos_cursor(0, 1);
        filename[strlen(filename)-2] = '\0';
        sprintf(infotext,"%s",filename);
        TLCD_Kette(infotext);
        TLCD_Kette("          ");
   }

}

void MP3Pause(bool pause) {
 if (pause) {BUF_Stop(); } else {BUF_Play();}
}

void MP3Test( ISO_VOLUME  *vol)
{
  int a=0;
  TLCD_clear();
  ISO_FILE_NODE    *node = vol->fileList;
  ulong             lba = node->lba;
  bool 				  pause=false;

  TLCD_clear();
  pos_cursor(0, 0);
  TLCD_Kette("*** MP3 Demo ***");

  lba = 0;  //Starte bei Song 1

  BUF_SetThreshold(BUF_GetSize()/2);
  VS_Reset();
  BUF_Play();

 if (BUF_GetFreeBytes() > 4096) {
      char *buf1;
      long  len = 2048, len1;
      int   bt;

      while (1)
      while (BUF_GetFreeBytes() > 2048) {

        BUF_Lock(-1, len, &buf1, &len1, 0, 0 );
        len1=2048;
        CD_ReadBlocks(buf1, lba++, 1);
        BUF_Unlock(2048);
        UpdateLCDInfo(vol , lba);

        bt = inp(0x600);
        if ((bt & 0x01)==0) { TLCD_clear(); TLCD_Kette("Back"); lba = getPrevMP3(vol, lba); while (inp(0x600)!=0xFF); BUF_Clear();VS_Reset(); BUF_Play();}
        if ((bt & 0x02)==0) { TLCD_clear(); TLCD_Kette("Next"); lba = getNextMP3(vol, lba); while (inp(0x600)!=0xFF); BUF_Clear();VS_Reset(); BUF_Play();}
        if ((bt & 0x04)==0) { TLCD_clear(); TLCD_Kette("Stop"); BUF_Stop(); while (inp(0x600)!=0xFF);}
        if ((bt & 0x08)==0) { TLCD_clear(); TLCD_Kette("Play"); BUF_Play(); while (inp(0x600)!=0xFF); }
        if ((bt & 0x10)==0) { TLCD_clear(); TLCD_Kette("Pause"); MP3Pause(!pause); pause=!pause; while (inp(0x600)!=0xFF); }
        if ((bt & 0x20)==0) { TLCD_clear(); TLCD_Kette("Ende"); while (inp(0x600)!=0xFF); return;}
      }
  }

Exit:
}


/******************************************
 ** ENDE
 **/

void HttpTest()
{
  /* Volume */
  int  vol        = 255;
//  VS_SetVolume(vol, vol);

  for(;;) {
    char str[80];
    printf("enter URL: ");
    readline(str, sizeof(str));
    printf("\n");
    if (strlen(str) == 0)
      break;
    http_get(str);
  }
}


/**************************/

void CD_ListTOC()
{
  CD_TOC  toc;
  CD_ReadTOC( &toc );

  printf( "- track # ----- start -- length ---------  mode -\n");
  for (int i=0; i<toc.num_tracks; i++)
    if (toc.track[i].data)
      printf( "  track %02d:  %8ld, %8ld (%3ld Mb),  data\n",
              i+1, toc.track[i].address, toc.track[i].length,
              (toc.track[i].length * 2048L) >> 20 );
    else  {
      CD_MSF  start, len;
      start = LBA_To_MSF( toc.track[i].address );
      len   = LBA_To_MSF( toc.track[i].length  );

      printf( "  track %02d:  %2d:%02d.%02d, %2d:%02d.%02d (%3ld Mb), audio\n",
              i+1, start.minute, start.second, start.frame,
              len.minute, len.second, len.frame,
              (toc.track[i].length * 2048) >> 20 );
    }
  printf( "  %d data track(s), %d audio track(s), %ld blocks.\n",
          toc.num_data_tracks, toc.num_audio_tracks, toc.volume_size );
}
/****************************************************************************/


/****************************/
int main(int argc, char* argv[])
{
 unsigned int mode;

 /*DEMO
  I2C_select_clock_pin(11);
  I2C_select_data_pin(4);
  I2C_init();

  mas_basics();
  exit(0);
 /*DEMO*/

  I2C_select_clock_pin(11);
  I2C_select_data_pin(10);
  I2C_init();

  mas_basics();

  TLCD_init();
  TLCD_Kette(" CLASSICdigital!");

  pos_cursor(0, 1);
  TLCD_Kette(VERSION);
  RTX_Sleep_Time(2000);


  if (!CheckBIOS())
    return -1;

  SYS_SetSTDIOFocus(SYS_FOCUS_APP);

  pos_cursor(0, 1);
  TLCD_Kette("  Mount CD...");



  //RC_Init();
  VS_Init();
  //BUF_Init(16*1024, 128*1024L);



  //RC_Init();
  printf("Taste!");
  //getch();
  /*I2C Bus Init*/

/*
  I2C_release();
  VOL_ADR = I2C_scan(0x10,0xFF);
  printf("Found chip at adress: %d\n",VOL_ADR);
  getch();
  I2C_transmit_char(VOL_ADR,0xFF);
  I2C_release();
*/

  /*
   BIT 0 ->LOW = DOWN     ->HIGH = UP
   BIT 1 ->LOW = INC      ->HIGH = nix
   BIT 2 ->LOW = SELECT   Volumen Poti
   BIT 4 ->LOW = MP3      ->HIGH = CD
  */

  /************************************************************
   * Only Used by CD ROM Mode !!!!!
   ************************************************************ */
  printf("Init Buses:\n");
  //PFE_EnableDataBus( 0xffff, 1 );
  pfe_enable_bus ( 0xffff, 1);
  //PFE_EnablePCS( 1<<1 );
  pfe_enable_pcs ( 1<<1 );

  pfe_enable_pcs(5);  //CS 1
  pfe_enable_pcs(6);  //CS 2

  printf("INIT ATA...\n"); ATA_Init();
  printf("INIT CD...\n");  CD_Init();

  printf( "\nwaiting for cd...\n" );
//CD_SENSE info;

  while (!kbhit()) {
    if (CD_TestUnitReady() == ERR_OK) break;
/*    CD_Sense(info);
    printf("Error_Code: %X  %X Sense_Key : %X ASC: %X  ASCQ %X\n", info.Error_Code, info.Sense_Key, info.ASC, info.ASCQ);
    if (info.Sense_Key != 0) break;*/
    RTX_Sleep_Time(100);
  }

  printf("Run...");

/*  CD_SetSpeed( 1 * CD_1XSPEED); */
  CD_SetMaxSpeed();
  CD_NoCRC();  /* FEHLER KORREKTUR ABBRECHEN*/

  ISO_VOLUME  vol;
  ERROR  error;

  CD_ListTOC();
  /* ***********
  return 0;     */

  error = ISO_InitVolume( &vol );
  if (error)  printf( "  error: %x.\n", error );

  TLCD_clear();
  if (IsAudioCD()) { TLCD_Kette("Audio CD"); mode=1;}
  if (!error) {TLCD_Kette("MP3-Daten CD"); mode=2;}

  CD_Player mycd(false);

     switch (mode) {
      case 1: /*InitVolChip(0xFF); */ /*Audio_CDPlayer(); */  RC_Init(); mycd.inter(); break;
      case 2: /*InitVolChip(0xF7); */
              MP3Test(&vol);
              break;
      case 3: HttpTest();        break;
     }

  BUF_Done();
  VS_Done();

  RC_Done();

  SYS_SetSTDIOFocus(SYS_FOCUS_BOTH);
  printf("done...\n");
  return 0;
}
