#ifndef volctrl__h

#include "i2c_api.h"
#define volctrl__h

unsigned char VOL_ADR=0x00;
unsigned char VOL_STATE=0xFF;


/***********************************************/
//CD Mode: 0xFF
//MP3 Mode: 0x07
unsigned char InitVolChip(unsigned char intval=0xFF) {
  I2C_transmit_char(VOL_ADR,intval);
  I2C_release();
  VOL_STATE=intval;
  printf("Init Vol Chip at ADR: %X",VOL_ADR);

  return intval;
}

unsigned char VolInc(unsigned char step=1) { //8421
  unsigned char val = (VOL_STATE & 0xF9);    //1001
                                           //CSIU
  I2C_transmit_char(VOL_ADR,0xFB);         //1010   //CD & Chip Select  & UP
  I2C_release();

  I2C_transmit_char(VOL_ADR,0xF8);         //1000    //CD & Chip Select & UP & INC
  I2C_release();

  I2C_transmit_char(VOL_ADR,0xFB);         //1010    //CD & Chip Select & UP
  I2C_release();


//  I2C_transmit_char(VOL_ADR,val);
  VOL_STATE= val;
  printf("Inc VOL: %X\n",VOL_ADR);
  return val;
}

unsigned char VolDec(unsigned char step=1) { //8421
  unsigned char val = (VOL_STATE & 0xF8);    //1000
  I2C_transmit_char(VOL_ADR,val);
  I2C_release();
  VOL_STATE= val;
  printf("DEC VOL: %X\n",VOL_ADR);
  return val;
}

  /*
  1 BIT 0 ->LOW = DOWN     ->HIGH = UP
  2 BIT 1 ->LOW = INC      ->HIGH = nix
  4 BIT 2 ->LOW = SELECT   Volumen Poti
  8 BIT 4 ->LOW = MP3      ->HIGH = CD
  */

#endif